<?xml version="1.0"?> 

<xsl:stylesheet 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	version="1.0"
	xmlns:dc="http://purl.org/dc/elements/1.1/">
	
	<xsl:output 
		method="xml" 
		indent="yes"
		doctype-system="http://tarantula.students.cs.uu.nl/~pjede/"
		doctype-public="-//WKOK//PJEDE//DATAFORMAT"/>

	<!-- Default regel, niks doen. Hierdoor wordt er alleen op de gewenste elementen gematched en word het gebruik van de default-copy regel omzeild -->
	<xsl:template match="*">
		
	</xsl:template>
	
	<!-- Gedeelte om RSS 2.0 feeds naar ons eigen dataformaat om te zetten -->
	<xsl:template match="rss[@version=2.0]">
		<data>
			<xsl:apply-templates select="channel/item"/>
		</data>
	</xsl:template>	
		<xsl:template match="item">
			<item>
				<title><xsl:value-of select="title"/></title>
				<creator><xsl:value-of select="dc:creator"/></creator> <!-- Is er een RSS 2.0 feed die niet een Dublin Core gebruikt, dan heb je dus een lege creator en date -->
				<date><xsl:value-of select="dc:date"/></date>
				<identifier><xsl:value-of select="link"/></identifier>
				<content> <!-- Deze informatie stoppen wij dus voor een RSS 2.0 feed in de content -->
					Description:	<xsl:value-of select="description"/>
					Category:		<xsl:value-of select="category"/>
					Comments:		<xsl:value-of select="comments"/>
				</content>
			</item>
		</xsl:template>
	
	<!-- Gedeelte om iTunes tracks naar ons eigen dataformaat om te zetten -->
	<xsl:template match="plist">
		<data>
			<xsl:apply-templates select="dict/dict/dict"/>
		</data>
	</xsl:template> 	
		<xsl:template match="dict//dict//dict">
			<item>
				<xsl:apply-templates select="key[.='Name']"/>
				<xsl:apply-templates select="key[.='Artist']"/>
				<xsl:apply-templates select="key[.='Year']"/>
				<xsl:apply-templates select="key[.='Total Time']"/>
				<content>
					Genre:      <xsl:apply-templates select="key[.='Genre']"/>
				</content>
			</item>
		</xsl:template> 	
			<xsl:template match="key[.='Name']"> <!-- Wij beschouwen de Name uit de iTunes database dus als titel van een track -->
				<title><xsl:value-of select="following-sibling::string"/></title>
			</xsl:template>
			<xsl:template match="key[.='Artist']"> <!-- Wij beschouwen de Artist als creator van een track -->
				<creator><xsl:value-of select="following-sibling::string"/></creator>
			</xsl:template>
			<xsl:template match="key[.='Year']"> <!-- Aangezien onze date-tag geen echte datum aangeeft, maar meer een tijdbeschrijving is voor dit item, is hier het jaar van verschijnen relevant -->
				<date><xsl:value-of select="following-sibling::integer"/></date>
			</xsl:template>
			<xsl:template match="key[.='Genre']"> 
				<xsl:value-of select="following-sibling::string"/>
			</xsl:template>
			<xsl:template match="key[.='Total Time']"> 
				<identifier><xsl:value-of select="following-sibling::integer"/></identifier>
			</xsl:template>
</xsl:stylesheet>
