package servletPackage;
import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class Aggregator extends HttpServlet 
{
	private Schermen scherm;
	private Database database;
	private VerwerkInput verwerker;
	private Sessie sessie;
	
	public void init(ServletConfig config)
	{
		try
		{
			database = new Database();
			verwerker = new VerwerkInput(database);
			scherm = new Schermen(database, verwerker);
			sessie = new Sessie();
		}
		catch (Exception e)
		{
			// de init mag geen errors throwen, daarom moeten ze worden afgevangen
		}
	}
	
	public void doPost(HttpServletRequest request, HttpServletResponse response) 
	throws IOException, ServletException
	{	
		String [] sessieData = sessie.getID(request, response);
		PrintWriter out = response.getWriter();
		try
		{
			Util hulp = new Util();
			String[] requestBody = hulp.getSubmit(request);
			if(requestBody[0].equals("public_url"))
			{
				verwerker.verwerkPublicURL(requestBody[1], sessieData[1]);
				scherm.dataScherm(response, sessieData[1]);
			}
			else
			{
				if(requestBody[0].equals("private_file"))
				{
					verwerker.verwerkPrivateFile(requestBody[1], requestBody[2], sessieData[1]);
					scherm.dataScherm(response, sessieData[1]);
				}
				else
				{
					if(requestBody[0].equals("public_source"))
					{
						verwerker.verwerkCheckbox(requestBody[1], true, sessieData[1]);
						scherm.dataScherm(response, sessieData[1]);
					}
					else
					{
						if(requestBody[0].equals("private_source"))
						{
							verwerker.verwerkCheckbox(requestBody[1], false, sessieData[1]);
							scherm.dataScherm(response, sessieData[1]);
						}
						else
						{
							verwerker.verwerkCheckbox("error", false, sessieData[1]);
							scherm.dataScherm(response, sessieData[1]);
						}
					}
				}
			}
		}
		catch (Exception e)
		{
			out.println("waarschijnlijk probleem met de database-server");
			e.printStackTrace(out);
		}
	}
	
	public void doGet(HttpServletRequest request, HttpServletResponse response) 
	throws IOException, ServletException
    {	
		String [] sessieData = sessie.getID(request, response);				
		PrintWriter out = response.getWriter();
		try
		{
			if(request.getParameter("page") != null)
			{
		    	if(request.getParameter("page").equals("data"))
		    	{
		    		scherm.dataScherm(response, sessieData[1]);
		    	}
				else
				{
					if(request.getParameter("page").equals("summ"))
					{
						String item_nr = request.getParameter("item_nr");
						
						String selected = request.getParameter("selected");
					    if (item_nr != null && selected != null)
					    	verwerker.verwerkItem(item_nr, selected, sessieData[1]);
						scherm.summScherm(response, sessieData[1]);
					}
					else
					{
						if(request.getParameter("page").equals("select"))
						{
							String show_item = request.getParameter("show_item");
							scherm.selectScherm(response, show_item, sessieData[1]);
						}
						else
						{
							scherm.dataScherm(response, sessieData[1]);
						}
					}
				}
			}
			else
			{
				if (sessieData[0].equals("false"))
				{
					scherm.dataScherm(response, sessieData[1]);
				}
				else
				{
					scherm.selectScherm(response, null, sessieData[1]);
				}
			}	
		}
		catch (Exception e)
		{
			e.printStackTrace(out);
		}
    }
}