package servletPackage;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringReader;
import java.sql.ResultSet;
import java.sql.SQLException;

import javax.naming.NamingException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletResponse;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.stream.StreamSource;

public class Schermen //hierin staan de 3 functies die de 4 schermen produceren
{
	private Database database;
	private VerwerkInput verwerker;
	
	public Schermen(Database db, VerwerkInput vw)
	{
		this.verwerker = vw;
		this.database = db;
	}
	
	public void dataScherm(HttpServletResponse response, String user_id) throws IOException, ServletException, SQLException
	{
			ResultSet publiek = database.resultQuery("SELECT bron_nr, naam " +
													"FROM bronnen " +
													"WHERE publiek='true';");
			ResultSet privaat = database.resultQuery("SELECT b.naam, b.bron_nr, l.geselecteerd " +
													"FROM bronnen b, bronnenlist l " +
													"WHERE publiek='false' " +
													"AND b.bron_nr = l.bron_nr " +
													"AND user_id = '"+ user_id +"';");
		response.setContentType("text/html");
		PrintWriter out = response.getWriter();
		out.println("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">");
		out.println("<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en' lang='en'>");
		out.println("<head>");
		out.println("	<title>Data source list</title>");
		out.println(this.cssLink());
		out.println("</head>");
		out.println("<body>");
		out.println("	<div class='titel'>");
		out.println("		<h1>Web aggregator</h1>");
		out.println("	</div>");
		out.println("	<div class='menulist'>");
		out.println("		<a href='agg?page=summ'>Summary list</a>");
		out.println("		<a href='agg?page=select'>Selected list</a>");
		out.println("	</div>");
		out.println("	<div class='public'>");
		out.println("		<form action='agg' method='post' enctype='multipart/form-data'>");
		out.println("			<p>");
		out.println("				<h2>Public data sources</h2>");
			while(publiek.next())
			{
				String naam = publiek.getString("naam");
				String bron_nr = publiek.getString("bron_nr");
				String checked = new String();
				ResultSet geselecteerd = database.resultQuery(	"SELECT geselecteerd " +
																"FROM bronnenlist " +
																"WHERE user_id='"+ user_id +"';");
				if (geselecteerd.next())
				{
					if(geselecteerd.getString("geselecteerd").equals("t"))
						checked = "checked='checked'";
				}
				out.println("				<input type='checkbox' name='public_source' "+ checked +" value='" + bron_nr + "' />" + naam + "<br />");
			}
		out.println("				<input type='submit' />");
		out.println("			</p>");	
		out.println("		</form>");
		out.println("		<form action='agg' method='post' enctype='multipart/form-data'>");
		out.println("			<p>");
		out.println("				<p>Add url</p>");
		out.println("				<input type='text' name='public_url' />");
		out.println("				<input type='submit' value='Add source' />");
		out.println("			</p>");	
		out.println("		</form>");
		out.println("	</div>");
		out.println("	<div class='private'>");
		out.println("		<form action='agg' method='post' enctype='multipart/form-data'>");
		out.println("			<p>");
		out.println("				<h2>Private data sources</h2>");
			while(privaat.next())
			{
				String naam = privaat.getString("naam");
				String bron_nr = privaat.getString("bron_nr");
				String checked = new String();
				if(privaat.getString("geselecteerd").equals("t"))
					checked = "checked='checked'";
				out.println("				<input type='checkbox' name='private_source' "+ checked +" value='" + bron_nr + "' />" + naam + "<br />");
			}
		out.println("				<input type='submit' />");
		out.println("			</p>");
		out.println("		</form>");
		out.println("		<form action='agg' method='post' enctype='multipart/form-data'>");
		out.println("			<p>");
		out.println("				<p>Add url</p>");
		out.println("				<input type='file' name='private_file' />");
		out.println("				<input type='submit' value='Upload file' />");
		out.println("			</p>");	
		out.println("		</form>");
		out.println("	</div>");
		out.println("</body>");
		out.println("</html>");
	}
	
	public void summScherm(HttpServletResponse response, String user_id) 
	throws TransformerException, TransformerConfigurationException, FileNotFoundException, IOException, SQLException, NamingException
	{
		response.setContentType("text/html");
		PrintWriter out = response.getWriter();
			verwerker.updateItems(user_id);
			String link = "http://tarantula.students.cs.uu.nl:8080/pjede/agg?page=summ";
			String item_nr = new String();
			String titel = new String();
			String selected = new String();
			ResultSet result = database.resultQuery("SELECT s.item_nr, selected, presented, shown, titel,times_seen " + 
													"FROM summary_list s, items i " +
													"WHERE s.item_nr = i.item_nr " +
													"AND s.user_id = '"+ user_id + "' " +
													"ORDER BY presented, shown, times_seen DESC, datum DESC;");	
		out.println("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">");
		out.println("<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en' lang='en'>");
		out.println("<head>");
		out.println("	<title>Summary list</title>");
		out.println(this.cssLink());
		out.println("</head>");
		out.println("<body>");
		out.println("	<div class='titel'>");
		out.println("		<h1>Web aggregator</h1>");
		out.println("	</div>");
		out.println("	<div class='menulist'>");
		out.println("		<a href='agg?page=data'>Datasource list</a>");
		out.println("		<a href='agg?page=select'>Selected list</a>");
		out.println("	</div>");
		out.println("	<div class='summary'>");
		out.println("		<h2>Summary list</h2>");
			String updateQuery = new String();
				while(result.next())
				{
					String toevoeging = "";
					String klasse = "";
					titel = result.getString("titel");
					item_nr = result.getString("item_nr");
					selected = result.getString("selected");
					if (result.getString("selected").equals("f"))
						toevoeging += " (not selected) ";
					else
					{	
						toevoeging += " (selected) ";
						klasse += " class = 'geselecteerd' ";
					}
					if (result.getString("shown").equals("f"))
						toevoeging += " (not shown) ";
					else
						toevoeging += " (shown) ";
					if (result.getString("presented").equals("f"))
						toevoeging += " (not presented) ";
					else
					{
						toevoeging += " (presented) ";
						if(result.getString("selected").equals("f"))
							klasse += " class = 'presented' ";
					}
					toevoeging += result.getString("times_seen") + " times seen ";
					out.println("<a href='"+ link+ "&amp;item_nr=" + item_nr + "&amp;selected=" + selected + "' "+ klasse +">" + titel + toevoeging);
					out.println("</a><br>");
					updateQuery += "item_nr = " + item_nr + " OR ";
				}
			if(!updateQuery.equals(new String()))
			{
				updateQuery = updateQuery.substring(0, (updateQuery.length()-4));
				database.nonResultQuery("UPDATE summary_list " + 
										"SET presented = true " + 
										"WHERE presented = false  " +
										"AND user_id = '"+ user_id + "' " +
										"AND (" + updateQuery + ") ;"); 
			}
		out.println("	</div>");
		out.println("</body>");
		out.println("</html>");
	}
	public void selectScherm(HttpServletResponse response, String show_item, String user_id) 
	throws IOException, ServletException, SQLException, NamingException, TransformerException
	{
		response.setContentType("text/html");
		PrintWriter out = response.getWriter();
			String link = "http://tarantula.students.cs.uu.nl:8080/pjede/agg?page=select";
			String item_nr = new String();
			String titel = new String();
			String selected = new String();
			ResultSet result = database.resultQuery("SELECT titel, selected_on, s.item_nr " + 
													"FROM summary_list s, items i " + 
													"WHERE s.item_nr = i.item_nr " +
													"AND selected = true " + 
													"AND s.user_id = '"+ user_id + "' " +
													"ORDER BY selected_on DESC LIMIT 50;");
		out.println("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">");
		out.println("<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en' lang='en'>");
		out.println("<head>");
		out.println("	<title>Selected list</title>");
		out.println(this.cssLink());
		out.println("</head>");
		out.println("<body>");
		out.println("	<div class='titel'>");
		out.println("		<h1>Web aggregator</h1>");
		out.println("	</div>");
		out.println("	<div class='menulist'>");
		out.println("		<a href='agg?page=data'>Datasource list</a>");
		out.println("		<a href='agg?page=summ'>Summary list</a>");
		out.println("	</div>");
		out.println("	<div class='selected'>");
		out.println("		<h2>Selected list</h2>");
			
			// Scherm 3
			while(result.next())
			{
				titel = result.getString("titel");
				item_nr = result.getString("item_nr");
				selected = result.getString("selected_on");
				out.println("<a href=" + link + "&amp;show_item=" + item_nr + ">");
				out.println(titel);
				out.println("Selected on: " + selected);
				out.println("</a><br>");
			}
		
		out.println("	</div>");
		out.println("	<div class='item'>");
			
			// Scherm 4
			if(show_item != null)
			{
				String content = new String();
				result = database.resultQuery(	"SELECT content " + 
												"FROM items " +
												"WHERE item_nr = " + show_item + " " +
												"AND item_nr IN (SELECT item_nr " +
																"FROM summary_list " +
																"WHERE user_id = '" + user_id + "');");
				// Updaten van shown
				database.nonResultQuery("UPDATE summary_list " +
										"SET shown = true " +
										"WHERE item_nr =" + show_item + " " +
										"AND user_id = '" + user_id + "';"); 
				database.nonResultQuery("UPDATE items " +
										"SET times_seen = times_seen +1 " +
										"WHERE item_nr =" + show_item + " " +
										"AND item_nr IN (SELECT item_nr " +
														"FROM summary_list " +
														"WHERE user_id = '" + user_id + "');");
				// tonen van content
				if(result.next())
				{
					content = result.getString("content");
					XSLTransformer trans = new XSLTransformer();
					content = trans.transformer(new StreamSource (new StringReader(content)), 2);
					out.println("<br>" + content);
				}
			}
		
		out.println("	</div>");
		out.println("</body>");
		out.println("</html>");
	}
	
	//hulpfuncties
	private String cssLink()
	{
		return "	<link href='http://tarantula.students.cs.uu.nl/~pjede/agg.css' rel='stylesheet' type='text/css' />";
	}
}