package servletPackage;
import java.util.Iterator;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.fileupload.DiskFileUpload;
import org.apache.commons.fileupload.FileItem;

public class Util 
{
	private String[] resultaat;
	
	public Util()
	{
		resultaat = new String[3];
	}
	
	public String escapeString(String tekst)
	{
		//deze functie voorkomt SQL Injection in de database
		tekst = tekst.replaceAll("\'", "&#039;");
		tekst = tekst.replaceAll("\"", "&quot;");
		return tekst;
	}

	public String [] getSubmit (HttpServletRequest request)
	{
		resultaat[0] = "Error";
		resultaat[1] = "";
		
		try
		{
		  	DiskFileUpload upload = new DiskFileUpload();
		  	List items = upload.parseRequest(request);
			Iterator iter = items.iterator();

			while (iter.hasNext()) 
			{
			    FileItem item = (FileItem) iter.next();
				if (item.isFormField()) 
				{
				 	resultaat[0] = item.getFieldName();
				   	resultaat[1] += (item.getString() + " ");
				} 
				else 
				{
				  	resultaat[0] = "private_file";
				   	resultaat[1] = item.getString();
				   	resultaat[2] = item.getName();
				}
			}
			return resultaat;
			
		}
		catch(Exception e)
		{	
			return resultaat;
		}
	}

	public String makeURL (String url)
	{
		url = url.toLowerCase();
		String patroon = new String();
		boolean http = false;
		
		//weghalen van spaties
		while (url.charAt(0)== ' ')
			url = url.substring(1,url.length());
		
		if (url.length()>6)
		{	
			if (url.substring(0,7).equals("http://"))
			{	
				http = true;
				if (url.length()>10)
				{
					if (url.substring(7,10).equals("www"))
					{
						patroon = "http://www\\..+\\.\\w+(/.+)?";
					}
					else
					{
						patroon = "http://.+\\.\\w+(/.+)?";
					}
				}
			}
			else
			{	
				if (url.length()>3)
				{
					if (url.substring(0,3).equals("www"))
					{
						patroon = "www\\..+\\.\\w+(/.+)?";
					}
					else
					{
						patroon = ".+\\.\\w+(/.+)?";
					}
				}
			}
		}
		else
		{
			if (url.length()>3)
			{
				if (url.substring(0,3).equals("www"))
				{
					patroon = "www\\..+\\..{2,3}(/.+)?";
				}
				else
				{
					patroon = ".+\\..{2,3}(/.+)?";
				}
			}
		}
		
		Pattern p = Pattern.compile(patroon);
		Matcher vergelijker = p.matcher(url);

		if (vergelijker.matches())
		{
			if (http == false)
			{
				url = "http://" + url;
			}
			return url;
		}
		else
		{
			return "Foute link";
		}
	}
}