package servletPackage;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.StringReader;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.naming.NamingException;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.stream.StreamSource;

public class VerwerkInput 
{
	private Database database;
	private XSLTransformer transformer;
	private Util hulp;
	
	public VerwerkInput (Database db)
	{
		this.database = db;
		this.transformer = new XSLTransformer();
		hulp = new Util();
	}
	
	public void verwerkItem(String s, String bool, String user_id) throws SQLException
	{
		String query = null;
	    SimpleDateFormat datum = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
	    Date now = new Date();
	    
		try
		{
			int itemnr = Integer.parseInt(s);
			if (bool.equals("f"))
			{
				query = 	"UPDATE summary_list " +
							"SET selected = true, selected_on = '" + datum.format(now) +  "' " +
							"WHERE item_nr = " + String.valueOf(itemnr) + " " +
							"AND selected = false " +
							"AND user_id = '" + user_id + "'; ";
			}
			else
			{
				query = 	"UPDATE summary_list " +
							"SET selected = false " +  
							"WHERE item_nr = " + String.valueOf(itemnr) + 
							" AND selected = true" +
							" AND user_id = '" + user_id + "';";
			}			
		}
		catch(Exception e)
		{
			//Deze exception wordt alleen gecatched als de gebruiker een item_nr in de GET heeft staan
			//die niet converteerbaar is naar een getal. De gebruiker heeft in dit geval dus zelf in zijn GET
			//zitten rotzooien.
		}
		if (query != null)
			database.nonResultQuery(query);	
	}
	
	public void verwerkPrivateFile(String fileinhoud, String filenaam, String user_id) 
	throws TransformerException, TransformerConfigurationException, FileNotFoundException, IOException, SQLException, NamingException
	{
		//deze functie zet een private file naar de database, dat is maakt entrys in de tabellen
		//bronnen, bronnenlist en items
		String bron_nr = sourceToDatabase(filenaam, false, user_id);
		if(bron_nr != null)
		{
			String xmlData = transformer.transformer(new StreamSource(new StringReader(fileinhoud)), 1);
			naarDatabase(xmlData, bron_nr);	
		}
	}
	
	public void updateItems(String user_id)
	throws TransformerException, TransformerConfigurationException, FileNotFoundException, IOException, SQLException, NamingException
	{
		//eerst alle bronnen eventueel nieuwe items toevoegen aan de items tabel voor de huidige gebruiker
		ResultSet result = database.resultQuery(	"SELECT bron_nr, link " +
													"FROM bronnen " +
													"WHERE publiek = true " +
													"AND bron_nr IN (SELECT bron_nr " +
																	"FROM bronnenlist " +
																	"WHERE user_id = '"+ user_id +"' " +
																	"AND geselecteerd = true); ");
		while(result.next())
		{
			String xmlData = transformer.transformer(new StreamSource(result.getString("link")), 1);
			naarDatabase(xmlData, result.getString("bron_nr"));
		}
		//nu ook alle nieuwe items aan de summary_list voor de huidige gebruiker toevoegen
		result = database.resultQuery(	"SELECT item_nr "+
										"FROM items "+
										"WHERE bron_nr IN (	SELECT bron_nr "+
															"FROM bronnenlist "+ 
															"WHERE user_id = '"+ user_id +"' "+ 
															"AND geselecteerd = true) "+
										"AND item_nr NOT IN (	SELECT item_nr "+
													"FROM summary_list "+
													"WHERE user_id = '"+ user_id +"');"); 
		while(result.next())
		{
			database.nonResultQuery("INSERT INTO summary_list (user_id, item_nr, shown, presented, selected) " +
					"VALUES ('"+ user_id +"', '"+ result.getString("item_nr") +"', false, false, false) ;");
		}
	}
	
	public void verwerkPublicURL(String link, String user_id) 
	throws TransformerException, TransformerConfigurationException, FileNotFoundException, IOException, SQLException, NamingException
	{
		if(! hulp.makeURL(link).equals("Foute link"))
			sourceToDatabase(link, true, user_id);
	}
	
	private String sourceToDatabase(String link, boolean publiek, String user_id) throws IOException, SQLException
	{
		RegEx reg1 = new RegEx();
		String naam;
		String bron_nr;
		naam = link;
		naam = hulp.escapeString(naam);
		link = hulp.escapeString(link);
		ResultSet result = database.resultQuery("SELECT bron_nr " +
												"FROM bronnenlist " +
												"WHERE user_id ='" + user_id + "' " +
												"AND bron_nr = (SELECT bron_nr " +
																"FROM bronnen " +
																"WHERE link= '" + link + "'); ");
		if(! result.next()) // bron zit niet in bronnenlist
		{
			// dit om de bron in de bronnen tabel toe te voegen
			database.nonResultQuery("INSERT INTO bronnen (link, publiek, naam) " +
									"VALUES ('"+ link +"', '"+ publiek +"', '"+ naam +"') ;");
			// dit om de bron aan de tabel die bijhoudt welke bronnen geselecteerd zijn
			// result kan worden hergebruikt
			result = database.resultQuery(	"SELECT bron_nr " +
											"FROM bronnen " +
											"WHERE link ='" + link + "' ;");
			result.next();
			bron_nr = result.getString("bron_nr");
			return bron_nr;
		}
		else
		{
			//dit om te zorgen dat er een error komt, want deze conditie hoort niet op te treden
			return null;
		}
	}
	
	public void naarDatabase(String xmlData, String bron_nr)
	{
		RegEx reg1 = new RegEx();
		RegEx reg2 = new RegEx();
		String gematched = reg1.regularExpression("(\\<item\\>.+?\\</item\\>)", xmlData, 1);
		Util hulp = new Util();
		
		while(gematched != null)
		{
			String titel = reg2.regularExpression("\\<title\\>(.+?)\\</title\\>", gematched, 1);
			String identifier = reg2.regularExpression("\\<identifier\\>(.+?)\\</identifier\\>", gematched, 1);
			String datum = reg2.regularExpression("\\<date\\>(.+?)\\</date\\>", gematched, 1);

			//aangezien gematched een compleet item bevat, moet dat in zijn geheel, voorzien van
			//doctype, xml en data tags de database in onder kolom content
			String content = 	"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" + 
								"<!DOCTYPE data PUBLIC \"-//WKOK//PJEDE//DATAFORMAT\" \"http://tarantula.students.cs.uu.nl/~pjede/data.dtd\">" +
								"<data>\n" + hulp.escapeString(gematched) + "\n</data>";
						
			titel = hulp.escapeString(titel);
			identifier = hulp.escapeString(identifier);
				
			try
			{
				this.database.nonResultQuery(	"INSERT INTO items (bron_nr, titel, identifier, content, datum, times_seen) " +
												"VALUES ("+ bron_nr +", '" + titel + "', '" + identifier + "', '" + content + "', '"+ datum +"', 0)");
			}
			catch (SQLException e)
			{
				//als hij hierin komt, bestaat het item dat net werd geprobeerd toe te voegen
				//zeer waarschijnlijk al. wij besluiten dan niks te doen. hoewel dit niet erg
				//netjes is, is het alternatief een extra query per item per datasource, en dat
				//lijkt ons nog erger.
			}
			gematched = reg1.continueMatch(1);
		}
	}
	
	public void verwerkCheckbox (String woorden, boolean publiek, String user_id) throws SQLException
	{
		String where = new String();;
		String bron_nr = new String();;
		database.nonResultQuery("UPDATE bronnenlist " +
								"SET geselecteerd = 'false' " +
								"WHERE user_id = '"+ user_id + "' " +
								"AND bron_nr IN (SELECT bron_nr " +
												"FROM bronnen " +
												"WHERE publiek = "+ publiek +") ;");
		for (int t = 0; t < woorden.length(); t++)
		{
			if (woorden.charAt(t) == ' ')
			{
				try 
				{
					database.nonResultQuery("INSERT INTO bronnenlist (bron_nr, user_id, geselecteerd) " +
											"VALUES ('"+ bron_nr +"', '"+ user_id +"', 'false');");
				}
				catch(Exception e)
				{
					//komt voor als de bron al in bronnelist staat voor de huidige user
				}
				where += " bron_nr = " + bron_nr + " OR ";
				bron_nr = "";
			}
			else
			{
				bron_nr += woorden.charAt(t);
			}
		}
		if(!woorden.equals("error"))
		{
			where = where.substring(0, where.length()-4);
			database.nonResultQuery("UPDATE bronnenlist " +
									"SET geselecteerd = true " +
									"WHERE ( "+ where +" ) " +
									"AND user_id = '"+ user_id + "' " + 
									"AND bron_nr IN (SELECT bron_nr " +
													"FROM bronnen " +
													"WHERE publiek = "+ publiek +") ;");
		}
	}
}