CREATE TABLE bronnen
(
	bron_nr bigserial,
	link text NOT NULL UNIQUE,
	publiek boolean NOT NULL,
	naam text NOT NULL,
	PRIMARY KEY (bron_nr)
);

CREATE TABLE bronnenlist
(
  bron_nr int8 NOT NULL,
  user_id char(32) NOT NULL,
  geselecteerd bool NOT NULL,
  PRIMARY KEY (bron_nr, user_id),
  FOREIGN KEY (bron_nr) REFERENCES bronnen(bron_nr)
);

CREATE TABLE items
(
	item_nr bigserial UNIQUE,
	bron_nr int8 NOT NULL,
	titel text NOT NULL,
	identifier text NOT NULL,
	content text NOT NULL,
	datum varchar(20) NOT NULL,
	times_seen integer NOT NULL,
	PRIMARY KEY (titel, identifier),
	FOREIGN KEY (bron_nr) REFERENCES bronnen(bron_nr) 
);

CREATE TABLE summary_list
(
  user_id char(32) NOT NULL,
  item_nr int4 NOT NULL,
  shown bool NOT NULL,
  presented bool NOT NULL,
  selected bool NOT NULL,
  selected_on timestamp,
  PRIMARY KEY (user_id, item_nr),
  FOREIGN KEY (item_nr) REFERENCES items(item_nr) 
);